// Controlling a servo position using a potentiometer (variable resistor)
// by Michal Rinott <http://people.interaction-ivrea.it/m.rinott>

#include <Servo.h>

#define SERVO_01 2
#define SERVO_02 3
#define SERVO_03 4
#define SERVO_04 5
#define SERVO_05 6

Servo servo_01;
Servo servo_02;
Servo servo_03;
Servo servo_04;
Servo servo_05;


int i;    // variable to read the value from the analog pin
byte readByte;
int servoPos_01;
int servoPos_02;
int servoPos_03;
int servoPos_04;
int servoPos_05;


void establishContact(){
  while (Serial.available() <= 0) {
    Serial.print('X');   // send a capital X
    delay(300);
  }
}


void initArm(){
  servoPos_01 = 1750;
  servoPos_02 = 1700;
  servoPos_03 = 1000;
  servoPos_04 = 1800;
  servoPos_05 = 1600;

  servo_01.writeMicroseconds(servoPos_01);
  servo_02.writeMicroseconds(servoPos_02);
  servo_03.writeMicroseconds(servoPos_03);
  servo_04.writeMicroseconds(servoPos_04);
  servo_05.writeMicroseconds(servoPos_05);
}

void setup(){

  servo_01.attach(SERVO_01, 500, 2500);
  servo_02.attach(SERVO_02, 500, 2500);
  servo_03.attach(SERVO_03, 500, 2500);
  servo_04.attach(SERVO_04, 500, 2500);
  servo_05.attach(SERVO_05, 500, 2500);

  initArm();


  // start serial port at 115200 bps:
  Serial.begin(115200);
  establishContact();  // send a byte to establish contact until receiver responds


}

void loop(){

  readByte = 0;
  if (Serial.available() > 0){//if we get a valid byte, read from serial:
    //get incoming byte:
    readByte = Serial.read();
    Serial.print('r');   // send a 'r' to initiate next data from computer
  }//if (Serial.available() > 0){

  if(readByte > 0){
    if(readByte == 'a'){
      if(servoPos_01 < 2500){
        servoPos_01++;
        servo_01.writeMicroseconds(servoPos_01);
      }
    }
    if(readByte == 'b'){
      if(servoPos_01 > 500){
        servoPos_01--;
        servo_01.writeMicroseconds(servoPos_01);
      }
    }

    if(readByte == 'c'){
      if(servoPos_02 < 2500){
        servoPos_02++;
        servo_02.writeMicroseconds(servoPos_02);
      }
    }
    if(readByte == 'd'){
      if(servoPos_02 > 500){
        servoPos_02--;
        servo_02.writeMicroseconds(servoPos_02);
      }
    }


    if(readByte == 'e'){
      if(servoPos_03 < 2500){
        servoPos_03++;
        servo_03.writeMicroseconds(servoPos_03);
      }
    }
    if(readByte == 'f'){
      if(servoPos_03 > 500){
        servoPos_03--;
        servo_03.writeMicroseconds(servoPos_03);
      }
    }

    if(readByte == 'g'){
      if(servoPos_04 < 2500){
        servoPos_04++;
        servo_04.writeMicroseconds(servoPos_04);
      }
    }
    if(readByte == 'h'){
      if(servoPos_04 > 500){
        servoPos_04--;
        servo_04.writeMicroseconds(servoPos_04);
      }
    }

    if(readByte == 'i'){
      if(servoPos_05 < 2500){
        servoPos_05++;
        servo_05.writeMicroseconds(servoPos_05);
      }
    }
    if(readByte == 'j'){
      if(servoPos_05 > 500){
        servoPos_05--;
        servo_05.writeMicroseconds(servoPos_05);
      }
    }

    if(readByte == 'Z'){
      initArm();
    }


  }



  //delay(15);
}
